'*************************************************************************
'   Calculates % of OT from a form Error of a scan And assigns the % value To variables In the PP
'
'   Application example
'
'  *  Here we decalre 2 variables setting the value at 0
'  *  Then we execute the script, passing the Name of the scan (In this example it is "SEC_CF_LE", the upper nad lower tollerance As values
'      And the Name of the variables (we use the names of the just declared variables)
'   * Then we make a comment command To show that the value changed. In the practical Cases you would use the variables For
'     reporting Output Or For some other scope...
'
'            ASSIGN/PERC_OUT_UT=0
'            ASSIGN/PERC_OUT_LT=0
'CS2        =SCRIPT/FILENAME= C:\PROGRAMMI\CURVEANALYZER\FINDPERCOUT.BAS
'            Function/Main,SHOW=YES,ARG1="SEC CF LE",ARG2=0.1,ARG3=-0.15,ARG4="PERC_OUT_UT",ARG5="PERC_OUT_LT",,
'            STARTSCRIPT/
'            ENDSCRIPT/
'            COMMENT/OPER,NO,"Percentage out of tol from upper side :" + PERC_OUT_UT
'                           ,"Percentage out of tol from lower side :" + PERC_OUT_LT
'
' 15.10.2009  Creation date                                      A.Mavrov
'
'*************************************************************************


Option Explicit

Dim App As Object
Dim Part As Object
Dim Cmds As Object
Dim Cmd As Object
Dim Fcmd As Object
Dim Mypoint As Object

Function InitPCD() As Boolean
    InitPCD = True
    Set App = CreateObject("PCDLRN.Application")
    If App Is Nothing Then
        MsgBox "PC-DMIS initialisation error!",48, "Error!"
        InitPCD = False
    Else
        Set Part = App.ActivePartProgram
        If Part Is Nothing Then
            MsgBox "Part Program not opened!", 48, "Error!"
            InitPCD = False
        Else
            Set Cmds = Part.Commands
            If Cmds Is Nothing Then
                MsgBox "Pointer to commands not valid!", 48, "Error!"
                InitPCD = False
            End If
        End If
    End If
End Function

Sub FindOut(ByVal Fname As String, UT As Double, LT As Double, POutUT As Double, POutLT As Double)
    Dim index, myindex, total, tot_com, pos As Integer
    Dim ustr As String
    Dim XM As Double, YM As Double, ZM As Double, XN As Double, YN As Double, ZN As Double, T As Double
    Dim VI As Double, VJ As Double, VK As Double
    Dim StringOut As String

  index=1
  tot_com=Cmds.Count  
  For index=1 To tot_com 
     Set Cmd = Cmds.Item(index)
     If Cmd.IsFeature Then
         If Len(Cmd.ID) > 0 Then
             ' all this stuff With [ is needed For making this script work inside the loops... 
             ustr = Cmd.ID
             pos=InStr(1,ustr,"[",1)             
             If pos <> 0 Then
                 ustr = Left(ustr, pos-1)      
             End If
             If ustr = Fname Then
               myindex=index
               Exit For
            End If
         End If
       End If
    Next index
    
    Set Cmd = Cmds.Item(myindex)

    If Cmd Is Nothing Then
        MsgBox "Feature not existing!", 48, "Error in Feature Name!"
        Exit Sub
    End If
    
    Set Fcmd = Cmd.FeatureCommand
    '214 corresponds To Type Basic Scan
    If  Cmd.Type <> 214 Then
        Cmd.Next
    End If
    total = Fcmd.NumHits
    POutUT=0
    POutLT=0
    For index = 1 To total
            T=Cdbl(Cmd.GetText (T_VALUE, index))            
            If T> UT Then POutUT=POutUT+1
            If T< LT Then POutLT=POutLT+1
    Next index
    POutUT=(POutUT/Total)*100
    POutLT=(POutLT/Total)*100
End Sub


Sub Main (NAM As String, UT As Double, LT As Double, PercOutUT As String, PercOutLT As String)
    Dim POutLT As Double, POutUT As Double
    Dim Var1 As Object            
    Dim Var2 As Object            
    ' --- InitPCD
    InitPCD
    ' --- Calculate % out 
    FindOut NAM, UT,LT,POutUT, POutLT   
    ' --- Set the variables
    Set Var1=Part.GetVariableValue(PercOutUT)
    Var1.LongValue=POutUT
    Part.SetVariableValue PercOutUT,Var1
    Set Var2=Part.GetVariableValue(PercOutLT)
    Var2.LongValue=POutLT
    Part.SetVariableValue PercOutLT,Var2
End Sub


